servo/models/customer.py
# -*- coding: utf-8 -*-

import phonenumbers
from django.db import models
from django.conf import settings

from mptt.managers import TreeManager
from django.core.validators import validate_email
from django.template.defaultfilters import slugify
from mptt.models import MPTTModel, TreeForeignKey
from django.utils.translation import ugettext_lazy as _

from pytz import country_names

from servo import defaults
from servo.models import Tag
from servo.models.device import Device


class CustomerGroup(models.Model):
    name = models.CharField(
        unique=True,
        max_length=255,
        default=_('New Group'),
        verbose_name=_('name')
    )

    slug = models.SlugField(editable=False)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        super(CustomerGroup, self).save()

    def __str__(self):
        return self.name

    class Meta:
        get_latest_by = 'id'
        app_label = "servo"
        ordering = ('id',)


class Customer(MPTTModel):
    parent = TreeForeignKey(
        'self',
        null=True,
        blank=True,
        on_delete=models.CASCADE,
        related_name='contacts',
        verbose_name=_('company'),
        limit_choices_to={'is_company': True}
    )
    name = models.CharField(
        max_length=255,
        verbose_name=_('name'),
        default=_('New Customer')
    )
    fullname = models.CharField(
        default='',
        editable=False,
        max_length=255
    )
    phone = models.CharField(
        default='',
        blank=True,
        max_length=32,
        verbose_name=_('phone')
    )
    email = models.EmailField(
        blank=True,
        default='',
        verbose_name=_('email')
    )
    street_address = models.CharField(
        blank=True,
        default='',
        max_length=128,
        verbose_name=_('address')
    )
    zip_code = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_('ZIP Code')
    )
    city = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_('city')
    )
    COUNTRY_CHOICES = [(k, country_names[k]) for k in sorted(country_names)]
    country = models.CharField(
        blank=True,
        max_length=2,
        choices=COUNTRY_CHOICES,
        verbose_name=_('Country'),
        default=settings.INSTALL_COUNTRY.upper(),
    )
    photo = models.ImageField(
        null=True,
        blank=True,
        upload_to="photos",
        verbose_name=_('photo')
    )

    groups = models.ManyToManyField(
        CustomerGroup,
        blank=True,
        verbose_name=_('Groups')
    )

    tags = models.ManyToManyField(
        Tag,
        blank=True,
        verbose_name=_('tags'),
        limit_choices_to={'type': 'customer'}
    )

    notes = models.TextField(
        blank=True,
        default='',
        verbose_name=_("notes")
    )

    devices = models.ManyToManyField(
        Device,
        blank=True,
        editable=False,
        verbose_name=_("devices")
    )

    created_at = models.DateTimeField(auto_now=True)
    is_company = models.BooleanField(
        default=False,
        verbose_name=_("company"),
        help_text=_('Companies can contain contacts')
    )

    objects = TreeManager()

    def get_contacts(self):
        return self.get_descendants(include_self=False)

    def get_phone(self):
        return phonenumbers.parse(self.phone, self.country)

    def get_standard_phone(self):
        n = self.get_phone()
        fmt = phonenumbers.PhoneNumberFormat.E164
        return phonenumbers.format_number(n, fmt)

    def get_international_phone(self):
        n = self.get_phone()
        fmt = phonenumbers.PhoneNumberFormat.INTERNATIONAL
        return phonenumbers.format_number(n, fmt)

    def get_national_phone(self):
        n = self.get_phone()
        fmt = phonenumbers.PhoneNumberFormat.NATIONAL
        return phonenumbers.format_number(n, fmt)

    def get_company_name(self):
        """Since we don't really have a "company" field in Servo,
        climb up the parent tree and return a concated name
        """
        return ', '.join([i for i in self.get_parents()])

    def valid_email(self):
        """
        Returns email address or raises ValidationError
        """
        try:
            validate_email(self.email)
            return self.email
        except Exception:
            pass

    def get_email_address(self):
        return '%s <%s>' % (self.name, self.email)

    def get_closest_prop(self, prop):
        """
        Gets the 'closest' value of a property
        """
        ancestors = self.get_ancestors(ascending=True, include_self=True)
        for a in ancestors:
            attr = getattr(a, prop)
            if attr:
                return attr

    def gsx_address(self, location):
        """
        Returns a dictionary that's compatibly with GSX's Address datatype
        """
        out = dict()

        out['country'] = location.get_country()
        out['city'] = self.get_closest_prop('city') or location.city
        out['zipCode'] = self.get_closest_prop('zip_code') or location.zip_code
        out['primaryPhone'] = self.get_closest_prop('phone') or location.phone
        out['emailAddress'] = self.get_closest_prop('email') or u'refused@apple.com'
        out['addressLine1'] = self.get_closest_prop('street_address') or location.address

        try:
            (out['firstName'], out['lastName']) = self.name.split(" ", 1)
        except Exception:
            out['firstName'], out['lastName'] = self.name, self.name

        return out

    def get_property(self, key):
        """
        Returns the value of a specific property
        """
        result = None
        ci = ContactInfo.objects.filter(customer=self)
        for i in ci:
            if i.key == key:
                result = i.value

        return result

    @property
    def firstname(self):
        return self.name.split(" ")[0]

    @property
    def lastname(self):
        return self.name.split(" ")[1].rstrip(',')

    def get_fullname(self):
        """
        Gets the entire name tree for this customer
        """
        title = list()

        for a in self.get_ancestors():
            title.append(a.name)

        if len(title) < 1:
            return self.name

        return self.name + " - " + str(", ").join(title)

    def fullprops(self):
        """
        Get the combined view of all the properties for this customer
        """
        props = {}
        for r in self.contactinfo_set.all():
            props[r.key] = r.value

        return props

    def get_group(self):
        try:
            return self.groups.latest('id').slug
        except CustomerGroup.DoesNotExist:
            return "all"

    def get_absolute_url(self):
        return "/customers/%s/%d/" % (self.get_group(), self.pk)

    def get_icon(self):
        return 'icon-briefcase' if self.is_company else 'icon-user'

    def save(self, *args, **kwargs):
        self.zip_code = self.zip_code.replace(' ', '')

        super(Customer, self).save(*args, **kwargs)
        fn = self.get_fullname()

        if self.fullname != fn:
            self.fullname = fn
            self.save()

            for o in self.orders.all():
                o.customer_name = fn
                o.save()

    class Meta:
        app_label = "servo"

    class MPTTMeta:
        order_insertion_by = ['name']

    def __str__(self):
        return self.name


class ContactInfo(models.Model):
    customer = models.ForeignKey(Customer, on_delete=models.CASCADE)
    key = models.CharField(max_length=255)
    value = models.CharField(max_length=255)

    class Meta:
        app_label = 'servo'
        # Only allow a field once per customer
        unique_together = ('customer', 'key',)

servo/models/device.py
# -*- coding: utf-8 -*-

import re
import gsxws
from gsxws import diagnostics
from os.path import basename
from django_countries import countries
from django.core.validators import RegexValidator

from django.db import models
from django.conf import settings
from django.core.files import File
from django.core.cache import cache
from django.dispatch import receiver
from django.utils.text import slugify
from django.urls import reverse
from django.db.models.signals import post_save

from django.contrib.contenttypes.fields import GenericRelation

from django.utils.translation import ugettext_lazy as _
from django.contrib.contenttypes.models import ContentType

from servo import defaults
from servo.validators import sn_validator
from servo.models import GsxAccount, Product, DeviceGroup, TaggedItem


class Device(models.Model):
    """The serviceable device."""

    # @TODO: unique=True would be nice, but complicated...
    sn = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Serial Number"),
        validators=[sn_validator]
    )
    description = models.CharField(
        max_length=128,
        default=_("New Device"),
        verbose_name=_("Description")
    )
    brand = models.CharField(
        blank=True,
        max_length=128,
        default=_("Apple"),
        verbose_name=_("Brand")
    )
    reseller = models.CharField(
        blank=True,
        default='',
        max_length=128,
        verbose_name=_("Reseller")
    )
    created_at = models.DateTimeField(auto_now_add=True, null=True)
    imei = models.CharField(
        blank=True,
        default='',
        max_length=15,
        verbose_name=_("IMEI Number")
    )
    initial_activation_policy = models.CharField(
        default='',
        editable=False,
        max_length=128,
        verbose_name=_("Initial Activation Policy")
    )
    applied_activation_policy = models.CharField(
        default='',
        editable=False,
        max_length=128,
        verbose_name=_("Applied Activation Policy")
    )
    next_tether_policy = models.CharField(
        default='',
        editable=False,
        max_length=128,
        verbose_name=_("Next Tether Policy")
    )
    unlocked = models.BooleanField(default=None, editable=False, null=True)
    slug = models.SlugField(null=True, editable=False, max_length=128)
    PRODUCT_LINES = gsxws.products.models()
    LINE_CHOICES = [(k, x['name']) for k, x in PRODUCT_LINES.items()]
    product_line = models.CharField(
        max_length=16,
        default="OTHER",
        choices=LINE_CHOICES,
        verbose_name=_("Product Line")
    )
    products = models.ManyToManyField(
        Product,
        editable=False,
        help_text=_('Products that are compatible with this device instance')
    )
    config_code = models.CharField(default='', max_length=8, editable=False)
    configuration = models.CharField(
        blank=True,
        default='',
        max_length=256,
        verbose_name=_("Configuration")
    )

    WARRANTY_CHOICES = (
        ('QP', _("Quality Program")),
        ('CS', _("Customer Satisfaction")),
        ('ALW', _("Apple Limited Warranty")),
        ('APP', _("AppleCare Protection Plan")),
        ('CC', _("Custom Bid Contracts")),
        ('CBC', _("Custom Bid Contracts")),  # sometimes CC, sometimes CBC?
        ('WTY', _("3'rd Party Warranty")),
        ('OOW', _("Out Of Warranty (No Coverage)")),
        ('NA', _("Unknown")),
    )

    warranty_status = models.CharField(
        max_length=3,
        default="NA",
        choices=WARRANTY_CHOICES,
        verbose_name=_("Warranty Status")
    )
    username = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Username")
    )
    password = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Password")
    )
    purchased_on = models.DateField(
        null=True,
        blank=True,
        verbose_name=_("Date of Purchase")
    )
    purchase_country = models.CharField(
        blank=True,
        max_length=128,
        choices=countries,
        verbose_name=_("Country Of Purchase"),
        default=settings.INSTALL_COUNTRY.upper(),
    )

    sla_description = models.TextField(null=True, editable=False)
    has_onsite = models.BooleanField(
        default=False,
        help_text=_('Device is eligible for onsite repairs in GSX')
    )
    contract_start_date = models.DateField(null=True, editable=False)
    contract_end_date = models.DateField(null=True, editable=False)
    onsite_start_date = models.DateField(null=True, editable=False)
    onsite_end_date = models.DateField(null=True, editable=False)

    parts_and_labor_covered = models.BooleanField(default=False, editable=False)

    tags = GenericRelation(TaggedItem, null=True, blank=True)
    notes = models.TextField(blank=True, default="", verbose_name=_("notes"))

    photo = models.ImageField(
        null=True,
        blank=True,
        upload_to="devices",
        verbose_name=_("Photo")
    )

    image_url = models.URLField(
        null=True,
        blank=True,
        verbose_name=_("Image URL")
    )
    manual_url = models.URLField(
        null=True,
        blank=True,
        verbose_name=_("Manual URL")
    )
    exploded_view_url = models.URLField(
        null=True,
        blank=True,
        verbose_name=_("Exploded View")
    )

    is_vintage = models.BooleanField(
        default=False,
        verbose_name=_('Vintage'),
        help_text=_('Device is considered vintage in GSX')
    )
    fmip_active = models.BooleanField(default=False, editable=False)

    def is_apple_device(self):
        """
        Checks if this is a valid Apple device SN
        """
        valid_sn = gsxws.core.validate(self.sn, 'serialNumber')
        valid_imei = gsxws.core.validate(self.imei, 'alternateDeviceId')
        return valid_sn or valid_imei

    def get_sn(self):
        return self.sn or self.imei

    @property
    def has_warranty(self):
        return self.warranty_status in ('ALW', 'APP', 'CBC',)

    @property
    def tag_choices(self):
        return TaggedItem.objects.filter(content_type__model="device").distinct("tag")

    def add_tags(self, tags: list):
        tags = [x for x in tags if x != ''] # Filter out empty tags

        if not tags:
            return

        content_type = ContentType.objects.get_for_model(Device)
        
        for t in tags:
            tag, created = TaggedItem.objects.get_or_create(content_type=content_type,
                                                            object_id=self.pk,
                                                            tag=t)

        tag.save()
        

    def get_icon(self):
        if re.match('iPad', self.description):
            return "ipad"
        if re.match('iPhone', self.description):
            return "iphone"
        if re.match('iPod shuffle', self.description):
            return "ipod_shuffle"
        if re.match('iPod', self.description):
            return "ipod"
        if re.match('MacBook', self.description):
            return "macbook"

        return "imac"

    def set_wty_status(self, status):
        """
        Translates a GSX warranty status description
        to our internal representation
        """
        if not isinstance(status, basestring):
            return
        if re.match(r"Apple Limited", status):
            self.warranty_status = "ALW"
        if re.match(r"AppleCare", status):
            self.warranty_status = "APP"
        if re.match(r"Customer Satisfaction", status):
            self.warranty_status = "CSC"
        if re.match(r"Custom Bid", status):
            self.warranty_status = "CBC"
        if re.match(r"Out Of", status):
            self.warranty_status = "OOW"

    def to_dict(self):
        result = {'sn': self.sn}
        result['description'] = self.description
        result['warranty_status'] = self.warranty_status
        result['purchased_on'] = self.purchased_on
        result['purchase_country'] = self.purchase_country
        result['username'] = self.username
        result['password'] = self.password
        return result

    @classmethod
    def from_dict(cls, d):
        if d.get('_pk'):
            return cls.objects.get(pk=d['_pk'])

        device = Device()

        for k, v in d:
            if k.startswith('_'):
                continue
            setattr(device, k, v)

        return device

    def to_gsx(self):
        """
        Returns the corresponding gsxws Product object
        """
        if len(self.imei):
            return gsxws.Product(self.imei)
        return gsxws.Product(self.sn)

    @classmethod
    def from_gsx(cls, sn, device=None, cached=True, user=None):
        """
        Initialize new Device with warranty info from GSX
        Or update existing one
        """
        sn = sn.upper()
        cache_key = 'device-%s' % sn

        # Only cache unsaved devices
        if cached and device is None:
            if cache.get(cache_key):
                return cache.get(cache_key)

        arg = gsxws.validate(sn)

        if arg not in ("serialNumber", "alternateDeviceId",):
            raise ValueError(_(u"Invalid input for warranty check: %s") % sn)

        product = gsxws.Product(sn)

        if user and user.location:
            ship_to = user.location.gsx_shipto
        else:
            gsx_act = GsxAccount.get_default_account()
            ship_to = gsx_act.ship_to

        wty = product.warranty(ship_to=ship_to)
        model = product.model()

        if device is None:
            # serialNumber may sometimes come back empty
            serial_number = wty.serialNumber or sn
            device = Device(sn=serial_number)

        from servo.lib.utils import empty

        if empty(device.notes):
            device.notes = wty.notes or ''
            device.notes += wty.csNotes or ''

servo/templates/checkin/confirmation.html
{% extends "checkin/index.html" %}
{% load i18n %}

{% block main %}
<div class="page-header">
  <h2>{% trans "Confirmation" %}</h2>
</div>
<form method="post" action="">
  {% csrf_token %}
  {% include "form_snippet.html" %}
  <button type="submit" class="btn btn-primary">{% trans "Submit" %}</button>
</form>
{% endblock main %}

servo/templates/checkin/customer_form.html
{% load i18n %}
{% load bootstrap3 %}

<div class="row">
	<div class="col-md-6">
		{% bootstrap_field customer_form.phone %}
	</div>
	<div class="col-md-6">
		{% bootstrap_field customer_form.email %}
	</div>
</div>

<div class="row">
	<div class="col-md-6">
		{% bootstrap_field customer_form.fname %}
	</div>
	<div class="col-md-6">
		{% bootstrap_field customer_form.lname %}
	</div>
</div>
<div class="row">
	<div class="col-md-6">
		{% bootstrap_field customer_form.address %}
	</div>
	<div class="col-md-6">
		{% bootstrap_field customer_form.company %}
	</div>
</div>
<div class="row">
	<div class="col-md-6">
		<div class="row">
			<div class="col-md-6">
				{% bootstrap_field customer_form.postal_code %}
			</div>
			<div class="col-md-6">
				{% bootstrap_field customer_form.city %}
			</div>
		</div>
	</div>
	<div class="col-md-6">
		{% bootstrap_field customer_form.country %}
	</div>
</div>
{% comment %}
<div class="row">
	<div class="col-md-12">
		{% bootstrap_field customer_form.notify_by_sms %}
		{% bootstrap_field customer_form.notify_by_email %}
	</div>
</div>
{% endcomment %}

{% block media %}
{% if request.user.is_authenticated %}
<script type="text/javascript">

	function SearchViewModel() {
		var self = this;
		self.results = ko.observableArray();

		self.loadCustomer = function(c){
			$.get('{% url "checkin-get_customer" %}?c=' + c.id, function(r){
				$('#id_fname').val(r.fname);
				$('#id_lname').val(r.lname);
				$('#id_address').val(r.address);
				$('#id_postal_code').val(r.postal_code);
				$('#id_city').val(r.city);
				$('#id_country').val(r.country);
				$('#id_email').val(r.email);
				$('#modal').modal('hide');
			});
		}
	}

	var svm = new SearchViewModel();
	ko.applyBindings(svm);

	$('#id_phone').next('span').on('click', function(){
		var q = encodeURIComponent($('#id_phone').val());
		$.get('?phone=' + q, function(r){
			svm.results(r);
			$('#modal').modal();
		});
	});
</script>
{% endif %}
{% endblock media %}

servo/templates/checkin/device_form.html
{% load i18n %}
{% load bootstrap3 %}

{% if device.fmip_active %}
	<div class="alert alert-danger" role="alert">
		{% trans "Find My iPhone is active!" %}
		<button type="button" class="close" data-dismiss="alert" aria-label="{% trans "Close" %}"><span aria-hidden="true">&times;</span></button>
	</div>
{% endif %}

{% if error %}
	<div class="alert alert-danger" role="alert">
		{{ error }}
		<button type="button" class="close" data-dismiss="alert" aria-label="{% trans "Close" %}"><span aria-hidden="true">&times;</span></button>
	</div>
{% endif %}

<div class="col-md-4">
	<img src="{{ device.get_image_url }}" alt="{{ device.description }}" class="device-image"/>
</div>
<div class="col-md-8">
	<div class="row">
		<div class="col-md-6">
			{% bootstrap_field device_form.sn %}
		</div>
		<div class="col-md-6">
			{% bootstrap_field device_form.description %}
		</div>
	</div>
	<div class="form-group">
		<label class="control-label" for="id_warranty_status">{% trans "Warranty Status" %}</label>
		<p>{{ device.get_warranty_status_display }}</p>
	</div>
	{% bootstrap_field device_form.purchased_on %}
	{% bootstrap_field device_form.purchase_country %}
	<div class="row">
		<div class="col-md-6">
		{% if device.is_mac %}
			{% bootstrap_field device_form.username %}
		{% endif %}
		</div>
		<div class="col-md-6">
			{% bootstrap_field device_form.password %}
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			{% bootstrap_field device_form.accessories %}
		</div>
	</div>
</div>
<script type="text/javascript">
	$('#id_sn').next('span').on('click', function(){
		var v = $('#id_sn').val().trim();
		if (v.length < 3) return false;
		var target = document.getElementById('main');
		var spinner = new Spinner().spin(target);
		$('#device_details').load('?sn='+v, function(r){
			spinner.stop();
		});
	});
</script>

servo/templates/checkin/error.html
{% extends "checkin/index.html" %}
{% load i18n %}

{% block title %}{% trans "An error occurred" %}{% endblock title %}

{% block main %}
<div class="container-narrow">
  <div class="jumbotron">
    <img src="{{ STATIC_URL }}/images/sadmac.png" alt="{% trans "An error occurred" %}" title="{% trans "An error occurred" %}"/>
    <p class="lead">{% trans "An error occurred." %}</p>
    <p>{{ message }}</p>
    <a class="btn btn-large btn-success" href="{{ url }}"><i class="glyphicon glyphicon-repeat"></i> {% trans "Try again" %}</a>
    <a class="btn btn-large btn-default" href="{% url 'accounts-login' %}"><i class="icon-refresh icon-white"></i> {% trans "Return to login page" %}</a>
  </div>
</div>
{% endblock main %}

servo/templates/checkin/index.html
{% load i18n %}{% load bootstrap3 %}<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <title>{% block title %}{{ title }}{% endblock title %}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="{{ STATIC_URL }}css/checkin.css" rel="stylesheet">
    <link href="{{ STATIC_URL }}bs3/css/timeline.css" rel="stylesheet">
    <link rel="stylesheet" href="{{ STATIC_URL }}bs3/css/bootstrap.min.css">
    <link rel="stylesheet" href="{{ STATIC_URL }}bs3/css/bootstrap-theme.min.css">
    <script src="{{ STATIC_URL }}js/jquery.min.js"></script>
    <script src="{{ STATIC_URL }}bs3/js/bootstrap.min.js"></script>
    <script src="{{ STATIC_URL }}js/knockout.js"></script>
  </head>
  <body id="main">
    <div class="navbar navbar-inverse navbar-fixed-top" role="navigation">
      <div class="container">
        <div class="collapse navbar-collapse">
          <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
        {% if request.user.is_authenticated %}
          <ul class="nav navbar-nav">
            <li class="dropdown">
              <a href="#" class="dropdown-toggle" data-toggle="dropdown">{% bootstrap_icon "map-marker" %} {{ request.session.checkin_location_name }} <b class="caret"></b></a>
              <ul class="dropdown-menu">
              {% for l in request.session.checkin_locations %}
                <li{% if l.pk == request.session.checkin_location %} class="active"{% endif %}><a href="?l={{ l.pk|safe }}">{{ l.name }}</a></li>
              {% endfor %}
              </ul>
            </li>
          </ul>
        {% endif %}
          <ul class="nav navbar-nav pull-right">
          {% if request.user.is_authenticated %}
            <li class="dropdown">
              <a href="#" class="dropdown-toggle" data-toggle="dropdown">{% bootstrap_icon "user" %} {{ request.session.checkin_user_name }} <b class="caret"></b></a>
              <ul class="dropdown-menu">
              {% for u in request.session.checkin_users %}
                <li{% if u.pk == request.session.checkin_user %} class="active"{% endif %}><a href="?u={{ u.pk|safe }}">{{ u.name }}</a></li>
              {% empty %}
                <li class="disabled"><a href="#">{% trans "No users found" %}</a></li>
              {% endfor %}
                <li class="divider"></li>
                <li><a href="{% url 'accounts-list_orders' %}">{% bootstrap_icon "log-in" %} {% trans "Go to Servo" %}</a></li>
                <li><a href="{% url 'accounts-logout' %}" data-modal="#modal">{% bootstrap_icon "off" %} {% trans "Log out" %}...</a></li>
              </ul>
            </li>
          {% endif %}
          </ul>
        </div><!--/.nav-collapse -->
      </div>
    </div>
    <div class="main container">
    {% if request.user.is_authenticated %}
      <div class="modal fade" id="modal">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
              <h4 class="modal-title">{% trans "Search results" %}</h4>
            </div>
            <div class="modal-body">
              <ul class="nav nav-pills nav-stacked" data-bind="foreach: results">
                <li><a href="#" data-bind="text: title, click: $parent.loadCustomer"></a></li>
              </ul>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Close" %}</button>
            </div>
          </div>
        </div>
      </div>
    {% endif %}
      <div class="row">
        <div class="col-md-12">
          {% bootstrap_messages %}
          {% block main %}(no content){% endblock main %}
        </div>
      </div>
    </div><!-- /container -->
    <script type="text/javascript" src="{{ STATIC_URL }}js/spin.js-2.1.0.min.js"></script>
    <script type="text/javascript" src="{{ STATIC_URL }}js/jquery.spin.new.js"></script>
    <script src="{{ STATIC_URL }}js/common.js"></script>
    {% block media %}{% endblock media %}
    <script type="text/javascript">
      $(function(){
        $( "#id_agree_to_terms" ).click(function() {
          $('#id_btn_submit').prop('disabled', !$(this).prop('checked'));
        });
      });
    </script>
  </body>
</html>

servo/templates/checkin/status-show.html
{% extends "checkin/index.html" %}
{% load bootstrap3 %}
{% load humanize %}
{% load i18n %}

{% block main %}
  <div class="page-header">
    <h2>{{ order.status_name }} {{ order.status_started_at|naturaltime|default:"" }}</h2>
    <p class="lead">{{ status_description }}</p>
  </div>
  {% if timeline|length %}
  <ul class="timeline">
  {% for i in timeline %}
    <li class="{% cycle '' 'timeline-inverted' %}">
      <div class="timeline-badge {{ i.get_badge }}">{% bootstrap_icon "ok" %}</i></div>
      <div class="timeline-panel">
      {% with i.status as status %}
        <div class="timeline-heading">
          <h4 class="timeline-title">{{ status.title }}</h4>
          <p>
            <small class="text-muted"><i class="fa fa-time"></i> {{ i.started_at|naturaltime }}</small>
          </p>
        </div>
        <div class="timeline-body">
          <p>{{ status.description }}</p>
        </div>
      {% endwith %}
      </div>
    </li>
  {% endfor %}
  </ul>
  {% endif %}
  <a href="" class="btn btn-default">{% bootstrap_icon "refresh" %} {% trans "Refresh" %}</a>
  <a href="{% url 'checkin-index' %}" class="btn btn-primary">{% trans "Return" %}</a>
{% endblock main %}

servo/templates/checkin/status.html
{% extends "checkin/index.html" %}
{% load bootstrap3 %}
{% load i18n %}

{% block main %}
  <div class="page-header">
    <h2>{% trans "Please enter your Service Order number" %}</h2>
  </div>
  <p>{% trans "The Service Order number is an 8-digit code printed on your work confirmation" %}</p>
  <form method="get" action="" class="nolabel">
    {% bootstrap_form form %}
  {% buttons %}
  <div class="pull-right">
    <a class="btn btn-default" href="{% url 'checkin-index' %}">{% trans "Back" %}</a>
    <button type="submit" class="btn btn-primary">
      {% bootstrap_icon "search" %} Submit
    </button>
  </div>
  {% endbuttons %}
  </form>
{% endblock main %}